# copyright= 'Huynh Duong Phuong Vi @ 2014-2015'
# suforyou.vn@gmail.com
module S4U
	module S4u_ScaleTool
		def self.scale(element,x,y,z)
			element.transformation = element.transformation*Geom::Transformation.new([x,0,0,0,0,y,0,0,0,0,z,0,0,0,0,1])
		end
		def self.resetscale()
			model =Sketchup.active_model
			model.start_operation Strings.GetString("Reset Scale")
			objects=[]
			select =model.selection 
			if select.length==0 
				UI.messagebox Strings.GetString("Select groups or components")
				return
			else
				objects=select.select{|e| e.is_a?Sketchup::Group or e.is_a?Sketchup::ComponentInstance }
			end
			if objects.length==0 
				UI.messagebox Strings.GetString("Select groups or components")
				return
			else
				Sketchup.set_status_text Strings.GetString(objects.length.to_s + " selected elements")
			end
			objects.each{|obj| 
				t=obj.transformation
				obj.transformation = Geom::Transformation.new(t.xaxis,t.yaxis,t.zaxis,t.origin)
			}
			select.add objects
			model.commit_operation
		end
		def self.scaletool(flag)
			model =Sketchup.active_model
			model.start_operation Strings.GetString("Scale Tools")
			objects=[]
			objects=model.selection.select{|e| e.is_a?Sketchup::Group or e.is_a?Sketchup::ComponentInstance}
			if objects.length==0                
				UI.messagebox Strings.GetString("Select groups or components")
				return
			end
			decimal="." ; decimal="," if Sketchup.parse_length "1,2"
			if flag==0
				prompts = [Strings.GetString("Axis?"),Strings.GetString("Distance?")]
				list = ["x|y|z",""]
				defaults = @axis ? (@distance ? [@axis,@distance] : [@axis,"10".to_l]) : ["z","10".to_l]   
				input = UI.inputbox(prompts,defaults,list,Strings.GetString("Enter Distance"))        
				if input
					@axis=input[0].to_s                  
					value=input[1].to_s.tr(',.',decimal)
				else
					return
				end
			elsif flag==1
				prompts = [Strings.GetString("Axis?"),Strings.GetString("Ratio?")]
				list = ["x|y|z",""]
				defaults =  @axis ? (@ratio ? [@axis,@ratio] : [@axis,"2"]) : ["z","2"]        
				input = UI.inputbox(prompts,defaults,list,Strings.GetString("Enter Ratio"))        
				if input
					@axis=input[0].to_s                                                                      
					value=input[1].to_s.tr(',.',decimal)
				else
					return
				end          
			else
				prompts = [Strings.GetString("Axis?"),Strings.GetString("Length?")]
				list = ["x|y|z",""]                
				defaults = @axis ? (@length ? [@axis,@length] : [@axis,"100".to_l]) : ["z","100".to_l]         
				input = UI.inputbox(prompts,defaults,list,Strings.GetString("Enter fixed Length"))        
				if input       
					@axis=input[0].to_s
					value=input[1].to_s.tr(',.',decimal)
				else
					return  
				end
			end
			case @axis
			when "x" 
				objects.each{|obj|  
					t=obj.transformation
					group1=model.active_entities.add_group obj   	
					t1=Geom::Transformation.new(t.xaxis,t.yaxis,t.zaxis,t.origin.clone)
					group1.transformation=t1                                               
					obj.transformation= t1.inverse*t 
					d=obj.bounds.width                                        
					tg1=group1.transformation
					vector=[obj.bounds.corner(0).x,0,0]
					vector.transform! t1
					po=obj.transformation.origin.transform Geom::Transformation.new vector                      
					group2=model.active_entities.add_group group1
					group2.transformation=Geom::Transformation.new(tg1.xaxis,tg1.yaxis,tg1.zaxis,po)
					group1.transformation=group2.transformation.inverse*tg1                       
					if flag==0
						begin                        
						value=value.to_l
						rescue ArgumentError                                                               
						value=value.to_f                             
						end                          
						@distance=value
						sx=0
						(sx=1+(value/ d))  if d!=0
						self.scale(group2,sx,1,1) if sx!=0
					elsif flag==1 	
						@ratio=value
						self.scale(group2,value.to_f,1,1) if value.to_f!=0
					else
						if d!=0
							begin
								value=value.to_l
								rescue ArgumentError                                                               
								value=value.to_f                             
							end  
								@length=value
								s= value/ d
							self.scale(group2,s,1,1)  
						end
					end
					group1.explode 
					model.selection.add group2.explode 
				}    
			when "y" 
				objects.each{|obj|  
					t=obj.transformation
					group1=model.active_entities.add_group obj
					t1=Geom::Transformation.new(t.xaxis,t.yaxis,t.zaxis,t.origin.clone)
					group1.transformation=t1                                               
					obj.transformation= t1.inverse*t 
					d=obj.bounds.height                                        
					tg1=group1.transformation
					vector=[0,obj.bounds.corner(4).y,0]
					vector.transform! t1
					po=obj.transformation.origin.transform Geom::Transformation.new vector                      
					group2=model.active_entities.add_group group1
					group2.transformation=Geom::Transformation.new(tg1.xaxis,tg1.yaxis,tg1.zaxis,po)
					group1.transformation=group2.transformation.inverse*tg1                       
					if flag==0 
						begin
							value=value.to_l
							rescue ArgumentError
							value=value.to_f
						end  
						@distance=value
						sy=0
						(sy=1+(value/ d))  if d!=0
						self.scale(group2,1,sy,1) if sy!=0
					elsif flag==1    
							@ratio=value
							self.scale(group2,1,value.to_f,1) if value.to_f!=0  
					else
						if d!=0
							begin
							value=value.to_l
							rescue ArgumentError
							value=value.to_f
							end  
								@length=value
							s= value/ d
							self.scale(group2,1,s,1)  
						end
					end
					group1.explode 
					model.selection.add group2.explode 
				}  
			else
				objects.each{|obj|  
					t=obj.transformation
					group1=model.active_entities.add_group obj
					t1=Geom::Transformation.new(t.xaxis,t.yaxis,t.zaxis,t.origin.clone)
					group1.transformation=t1
					obj.transformation= t1.inverse*t 
					d=obj.bounds.depth                                        
					tg1=group1.transformation
					vector=[0,0,obj.bounds.min.z]
					vector.transform! t1
					po=obj.transformation.origin.transform Geom::Transformation.new vector                      
					group2=model.active_entities.add_group group1
					group2.transformation=Geom::Transformation.new(tg1.xaxis,tg1.yaxis,tg1.zaxis,po)
					group1.transformation=group2.transformation.inverse*tg1                      
					if flag==0
						begin
							value=value.to_l
							rescue ArgumentError
							value=value.to_f
						end  
						@distance=value
						sz=0
						(sz=1+(value/ d))  if d!=0
						self.scale(group2,1,1,sz) if sz!=0  
					elsif flag==1
						value=value.tr(',.','.')
						@ratio=value.to_f
						self.scale(group2,1,1,value.to_f) if value.to_f!=0
					else                       
						if d!=0
							begin
								value=value.to_l
								rescue ArgumentError
								value=value.to_f
							end 
							@length=value
							s= value/ d
							self.scale(group2,1,1,s)  
						end
					end
					group1.explode                
					model.selection.add group2.explode 
				}       
			end
			model.commit_operation
		end
		class Scale_Reference
			def initialize 
				@golden_section=(1+Math.sqrt(5))/2
				@snap=20
				@strings=S4U::S4u_ScaleTool::Strings 
			end
			def activate  
				model=Sketchup.active_model
				@ip1=Sketchup::InputPoint.new
				@ip2=Sketchup::InputPoint.new
				@ip3=Sketchup::InputPoint.new
				@ip=Sketchup::InputPoint.new			
				@element=nil                      
				self.reset(model.active_view)
			end
			def getExtents
				bb = Sketchup.active_model.bounds
				bb.add @ip.position if @ip.valid?
				bb.add(@p1) if @p1
				bb.add(@p2) if @p2
				return bb
			end
			def deactivate(view)
			end
			def setstatus(view=nil)
				text = @strings.GetString("Scale reference") + ": "
				if @state==0 
					text+=@strings.GetString("Select First point")
				elsif @state==1
					text+= @strings.GetString("Select Second point")
				end
				Sketchup.status_text=text
				view.invalidate if view
			end
			def getMenu(menu)    
			end
			def draw(view) 
				model=view.model                   
				view.line_width=2
				view.drawing_color="red"
				if @ip && @ip.valid? 
					if @ip.display? 
						@ip.draw(view)   
					elsif @face || @edge
						(view.draw_points @ip.position, 7, 1, "red" )
					end
				end
				#if @state==1
					if @ip1.valid? && @ip2.valid?
						@ip1.draw(view) 
						view.drawing_color ="red"
						view.draw_line @ip1.position,@ip2.position 
						if @ip_shift && @shift_press && @state==1
							view.line_stipple = "."
							view.drawing_color ="blue"
							view.draw_line(@ip.position, @ip2.position)
							view.line_stipple = ""
							view.drawing_color ="red"
							p2_line=@ip.position.project_to_line([@ip1.position,@ip_shift])
							view.draw_points p2_line, 7, 2, "red"  if p2_line
						end
					end
				if @state==2	
					if @ip1.valid? && @ip3.valid?
						@ip3.draw(view) 
						view.drawing_color ="blue"
						view.draw_line @ip1.position,@ip3.position 
						if @ip_shift && @shift_press
							view.line_stipple = "."
							view.drawing_color ="blue"
							view.draw_line(@ip.position, @ip3.position)
							view.line_stipple = ""
							view.drawing_color ="red"
							p2_line=@ip.position.project_to_line([@ip1.position,@ip_shift])
							view.draw_points p2_line, 7, 2, "red"  if p2_line
						end
					end
				end                           
				self.setstatus
			end
			def set_pointonedge(x,y,view,ip,edge)
				p1=edge.start.position.clone
				p2=edge.end.position.clone
				return nil if edge.length < (view.pixels_to_model(5*@snap, p1))
				points= [Geom.linear_combination(2.0/3, p1,1.0/3, p2),Geom.linear_combination(1.0/3, p1,2.0/3, p2)]
				ph = view.pick_helper  
				ph.init(x, y)
				picked = points.find{|p| ph.test_point((p.transform ip.transformation),x,y,@snap) } 
				if picked
					ip1=Sketchup::InputPoint.new(picked.transform ip.transformation)
					ip.copy! ip1 
					view.tooltip="       " + @strings.GetString("~/3") 
					return ip
				end
				return nil
			end
			def set_special_point(x,y,view,ip)
				if ip.face 
					cf=center_face(ip.face).transform ip.transformation
					ph = view.pick_helper                        
					ph.init(x, y)
					picked = ph.test_point(cf,x,y,@snap)                         
					if picked
						ip1=Sketchup::InputPoint.new(cf) 
						@face=true
						view.tooltip="       " + @strings.GetString("Center face") 
						ip.copy! ip1                             
					else
						@edge=ip.face.edges.find{|e| set_pointonedge(x,y,view,ip,e) }
					end
				elsif ip.edge
					@edge=set_pointonedge(x,y,view,ip,ip.edge)
				end  
			end
			def find_special_point(x,y,view,p1,p2,ip,d1)
				if p1!=p2
					ph = view.pick_helper 
					vec=(p2-p1)
					vec.length=d1 
					p_square= p1 + vec
					screen_square=view.screen_coords p_square
					vec.length=d1*@golden_section
					p_golden1= p1 + vec
					screen_golden1=view.screen_coords p_golden1
					vec.length=d1/@golden_section
					p_golden2= p1 + vec
					screen_golden2=view.screen_coords p_golden2
					p=p2
					if ph.init(p_square.x, p_square.y) && ph.test_point(p2,screen_square.x, screen_square.y,(@snap-5))
						p2=p_square
						view.tooltip= "       " + @strings.GetString("Square")
					elsif ph.init(screen_golden1.x, screen_golden1.y) && ph.test_point(p2,screen_golden1.x, screen_golden1.y,(@snap-5))
						p2=p_golden1
						view.tooltip="       " + @strings.GetString("Golden section")
					elsif ph.init(screen_golden2.x, screen_golden2.y) && ph.test_point(p2,screen_golden2.x, screen_golden2.y,(@snap-5))
						p2=p_golden2
						view.tooltip="       " + @strings.GetString("Golden section")
					end
					if p!=p2
						ip.copy! Sketchup::InputPoint.new(p2)
						Sketchup::set_status_text (p1.distance p2).to_s, SB_VCB_VALUE
						return ip
					end
				end
			end
			def onMouseMove(flags, x, y, view)          
					@face=@edge=@point=nil
					if @state==0
						@ip.pick view,x,y 
						set_special_point(x,y,view,@ip)                
						view.invalidate if @ip.valid? 
					elsif @state==1 
						@ip.pick view,x,y,@ip1 
						set_special_point(x,y,view,@ip)
						if @shift_press && @ip_shift && @ip!=@ip1 && @ip2!=@ip1 && (@ip1.position!=@ip_shift)
							p2_line=@ip.position.project_to_line([@ip1.position,@ip_shift])
							@ip2.copy!(p2_line ? Sketchup::InputPoint.new(p2_line) : @ip)
						else
							@ip2.copy! @ip
						end
						@p2=@ip2.position
						view.invalidate if @ip.valid?
						length = @ip1.position.distance(@ip2.position)
						Sketchup::set_status_text length.to_s, SB_VCB_VALUE
					elsif @state==2	
						@ip.pick view,x,y,@ip1 
						set_special_point(x,y,view,@ip)
						if @shift_press && @ip_shift && @ip!=@ip1 && @ip2!=@ip1 && (@ip1.position!=@ip_shift)
							p2_line=@ip.position.project_to_line([@ip1.position,@ip_shift])
							@ip3.copy!(p2_line ? Sketchup::InputPoint.new(p2_line) : @ip)
						else
							@ip3.copy! @ip
						end
						@p3=@ip3.position
						view.invalidate if @ip.valid?
						length = @ip1.position.distance(@ip3.position)
						Sketchup::set_status_text length.to_s, SB_VCB_VALUE
					end
			end
			def onReturn(view)
			end
			def onLButtonDown(flags, x, y, view)
				if @state==0   
					if @ip.valid?
						@ip1.copy! @ip
						@p1=@ip1.position
						@state=1
						view.lock_inference if  view.inference_locked?
					end
				elsif @state==1 && @ip.valid? && (@ip1.position!=@ip.position)
					@state=2
					@p2=@ip2.position
					view.lock_inference if  view.inference_locked?
				elsif @state==2 
					@p3=@ip3.position
					process_scale
					reset view
				end 
				self.setstatus(view)
			end
			def cal(input)
				if op=input[/[\+\-\/\*]/]
					begin
					if input[/[\+\-]/]
						index= input.rindex(/[\+\-]/)
					elsif input[/[\*\/]/]
						index= input.rindex(/[\*\/]/)
					end
					if index
						if index>0
							s=[input[0..(index-1)],input[(index+1)..-1]]
						else
							s=["0",input[(index+1)..-1]]
						end
						op=input[index]
						if op=="+"
							value= cal(s[0]).to_s.to_f + cal(s[1]).to_s.to_f 
						elsif op=="-"
							value= cal(s[0]).to_s.to_f - cal(s[1]).to_s.to_f 
						elsif op=="*"
							value= cal(s[0]).to_s.to_f * cal(s[1]).to_s.to_f
						elsif op=="/"
							value= cal(s[0]).to_s.to_f / cal(s[1]).to_s.to_f
						end
					end
					rescue
						value=parse_length(input)
					end
				else
					value = parse_length(input)
				end	
				return parse_length(value)
			end
			def parse_length(input)
				(return 0) if !input
				input=input.to_s
				if !Sketchup.parse_length("1.1") 
					input.gsub!(/\./, ',')
				else
					input.gsub!(/\,/, '.')
				end
				begin
					value=input.to_l
				rescue 
					value=input.to_f
				end 
				return value
			end
			def process_scale(length=nil)
				model=Sketchup.active_model
				model.start_operation @strings.GetString("Scale reference"),true,false,false
				sels=model.selection.grep(Sketchup::Group || Sketchup::ComponentInstance)
				sels.each{|e|
					ta=e.transformation.to_a
					ta[11..13] = @p1.x,@p1.y,@p1.z
					tra=Geom::Transformation.new ta
					vec=@p2-@p1
					vect=vec.transform tra.inverse
					origin=@p1.transform e.transformation.inverse
					sc=sx=sy=sz=1
					dis=@p2.distance @p1
					if length 
						(sc= length/ dis) if dis!=0
					else
						dis1=@p3.distance @p1
						(sc= dis1/ dis) if dis!=0
					end
					sx=sc if vect.x.abs > (0.1/ (10**10))
						sy=sc if vect.y.abs > (1.0/ (10**10))
						sz=sc if vect.z.abs > (1.0/ (10**10)) 
					t=Geom::Transformation.scaling @p1,sx,sy,sz
					tp=Geom::Transformation.new @p1
					e.transformation = e.transformation*t
					origin_new=origin.transform e.transformation
					vt=@p1-origin_new
					trans=Geom::Transformation.translation vt
					e.transform! trans
				}
				model.commit_operation
				Sketchup.active_model.select_tool nil
			end		
			def get_vertices(face)
				return nil if not( face && (face.is_a?Sketchup::Face))
				ver=[]
				vertices=[]    
				vertices =face.vertices*3    
				(0..face.vertices.length-1).each { |i|   
					j=face.vertices.length+i
					p1=vertices[j-1].position.clone
					p2=vertices[j].position.clone
					p3=vertices[j+1].position.clone
					v1=p1.vector_to p2
					v2=p2.vector_to p3    
					ver.push vertices[j] if not( v1.samedirection? v2)
				}         
				return ver
			end
			def onKeyDown(key, repeat, flags, view)   
				if key==CONSTRAIN_MODIFIER_KEY 
					@shift_press=true
					if view.inference_locked?
						view.lock_inference
					elsif (@state==0 && @ip.valid?)
						view.lock_inference @ip
					elsif (@state==1 && @ip2.valid?)
						@ip_shift=@ip.position
						view.lock_inference @ip2,@ip1 
					elsif (@state==2 && @ip3.valid?)
						@ip_shift=@ip.position
						view.lock_inference @ip3,@ip1 
					end
				end          
				self.setstatus(view) 
			end        
			def onKeyUp(key, repeat, flags, view)
				if (key==CONSTRAIN_MODIFIER_KEY) 
					@shift_press=false
					view.lock_inference if view.inference_locked?
				elsif ((key==9) && IS_WIN ) || ((key==48) && IS_OSX) 
					@box_mode=(@box_mode==2) ? 0 : (@box_mode+1)     
				end    
				self.setstatus(view)
			end
			def onUserText(text, view)
				if @state==1
					if @ip.position!=@p1
						vec=@ip.position - @p1
						length=self.cal(text)
						Sketchup::set_status_text length.to_s, SB_VCB_VALUE	
						if length!=0 && vec.length>0
							vec.length=length                                      
							@p2=@p1 + vec   
							ip = Sketchup::InputPoint.new(@p2)                   
							@ip2.copy! ip
							@state=2
							view.lock_inference if  view.inference_locked?
						end
					end
				elsif @state==2
						length=self.cal(text)
						Sketchup::set_status_text length.to_s, SB_VCB_VALUE	
						process_scale(length)
				end
				self.setstatus(view)
			end 
			def center_face(face)
				vertices=get_vertices(face)
				return nil if !vertices
				numver=vertices.length
				cp=Geom::Point3d.new
				vertices.each{|v|
					cp.x=cp.x+v.position.x
					cp.y=cp.y+v.position.y
					cp.z=cp.z+v.position.z
				}
				cp.x=cp.x/ numver
				cp.y=cp.y/ numver
				cp.z=cp.z/ numver
				return cp
			end
			def onCancel(reason, view)
				self.reset(view)
			end
			def reset(view=nil)
				@state=0         
				@face=@edge=nil
				@ip1.clear
				@ip2.clear
				@ip3.clear
				@ip.clear      
				view.lock_inference if view && view.inference_locked?
				self.setstatus(view)
			end     
			def resume(view)
				self.setstatus(view)
			end
		end
		def self.scale_reference
			model=Sketchup.active_model
			sels=model.selection.grep((Sketchup::Group) || (Sketchup::ComponentInstance))
			if  sels.empty?
				UI.messagebox "Select Group or Component"
				return
			end
			Sketchup.active_model.select_tool Scale_Reference.new
		end
		def self.main(mode)
			case mode
			when 0,1,2
				self.scaletool mode
			else
				self.resetscale
			end
		end
	end
end
